<?php
/*
  $Id: qb_orders.php$

  Released under the GNU General Public License
*/
 Error_Reporting(E_ALL & ~E_NOTICE);

  DEFINE(__ENCODE_RESPONSE, true);



  DEFINE(__DEBUG, 1);
  DEFINE(__LANGUAGE_ID, 1);
  DEFINE(__DELIVERED_STATUS_ID, 'S'); // Delivered
  DEFINE(__DELIVERED_STATUS_NAME, 'Delivered');

  DEFINE(__PROCESSING_STATUS_ID, 'P');
  DEFINE(__PROCESSING_STATUS_NAME, 'Processing');

  DEFINE(__CLEARED_STATUS_ID, 'C');
  DEFINE(__CLEARED_STATUS_NAME, 'CLEARED');
  DEFINE(__DECLINED_STATUS_ID, 'X');
  DEFINE(__DECLINED_STATUS_NAME, 'DECLINE');
  DEFINE(__FRAUD_STATUS_ID, 'X');
  DEFINE(__FRAUD_STATUS_NAME, 'FRAUD');
  DEFINE(__PENDING_STATUS_ID, 'P');
  DEFINE(__PENDING_STATUS_NAME, 'PENDING');

//  DEFINE(__ENCODE_RESPONSE, false);
  DEFINE(__MAX_NUMBER_OF_OPTIONVALUES, 300);
  DEFINE(__STATUS_MESSAGE_MAX_LENGTH,500);
  DEFINE(__USERID_MAX_LENGTH,75);
  DEFINE(__PASSWORD_MAX_LENGTH,15);
  DEFINE(__COMMAND_MAX_LENGTH,15);



  $PHP_SELF = (isset($HTTP_SERVER_VARS['PHP_SELF']) ? $HTTP_SERVER_VARS['PHP_SELF'] : $HTTP_SERVER_VARS['SCRIPT_NAME']);




  require('thubxml.php');

  $default_vendor = 1;  // for store info
  global $ps_vendor_id,  $category_id,$itemCategory,
                        $itemManufacturer,$manufacturer_id,
                        $_err_message_arr,$item;
  global $mosConfig_absolute_path;

  $mosConfig_absolute_path=JPATH_SITE;
  $category_id=0;
  $manufacturer_id=0;
  $_err_message_arr=array();
  $ps_vendor_id=1;

 if (!isset($request_)) {
    if (isset($_POST)){
      $request_ = $_POST['request'];
      }
    else{
      $request_ = $HTTP_POST_VARS['request'];

      }
  }

    if (empty($request_)){

      exit;
    }
    global $db_;

    $db_ = &JFactory::getDBO();
    $db2 = &JFactory::getDBO();
	$db3 = &JFactory::getDBO();
	$dbShip = &JFactory::getDBO();
	$dbPayment = &JFactory::getDBO();
	
  // parse XML Request
    $request_ = trim(stripcslashes($request_));
	
    $xmlRequest = new xml_doc($request_);
	
    $xmlRequest->parse();
	
    $xmlRequest->getTag(0, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);




    if (strtoupper(trim($_tagName)) != 'REQUEST') {
        print(xmlErrorResponse('unknown', '9999-2',
                'Unknown request', STORE_NAME, ''));
        flush;exit;
    }
    if (count($_tagTags) == 0) {
        print(xmlErrorResponse('unknown', '9999-3',
                'REQUEST tag doesnt have necessry parameters', STORE_NAME, ''));
        flush;exit;
    }

    $RequestParams = Array();
    foreach ($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $tN, $tA, $tC, $tT);
        $RequestParams[strtoupper($tN)] = trim($tC);
    }

	if (!isset($RequestParams['COMMAND'])) {
        print(xmlErrorResponse('unknown', '9999-4',
                'Command is not set', STORE_NAME, ''));
        exit;
	}


    $RequestParams['COMMAND'] = strtoupper($RequestParams['COMMAND']);

  // print($RequestParams['COMMAND']);
    if(  ($RequestParams['COMMAND'] != ('GET'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'INVENTORY'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'SHIPPING'.'STATUS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'PAYMENT'.'STATUS'))){
          print(xmlErrorResponse('unknown', '9999-5',
                  'Unknown Command'.$RequestParams['COMMAND'], STORE_NAME, ''));
          exit;
     }

	if (isset($RequestParams['REQUESTID'])) $request_id = $RequestParams['REQUESTID'];

  // check for installed admin auth contribution and do authentification.
    if (!isset($RequestParams['USERID'])||empty($RequestParams['USERID']))     {
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-6',
    	        'UserID field is not set', STORE_NAME, ''));
    	exit;
    }
    $UserID = $RequestParams['USERID'];
    if (strlen($UserID)>__USERID_MAX_LENGTH){
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-7',
    	        'Field UserID more maximum value', STORE_NAME, ''));
    	exit;
    }

    if (!isset($RequestParams['PASSWORD'])||empty($RequestParams['PASSWORD']))   {
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-8',
    	        'Password field is not set', STORE_NAME, ''));
    	exit;
    }
    $Password = $RequestParams['PASSWORD'];
    if (strlen($Password)>__PASSWORD_MAX_LENGTH){
    	print(xmlErrorResponse($RequestParams['COMMAND'], '9999-9',
    	        'Field Password more maximum value', STORE_NAME, ''));
    	exit;
    }

    $q = "SELECT u.block,u.id,u.username, u.password, u.usertype"
         ." FROM #__users u"
         ." WHERE  u.username='".$UserID."'";
		   $db = &JFactory::getDBO();
   $db->setQuery($q);
   $row = NULL;
$row = $db->loadObject();


	if (!$row){
		
        print(xmlErrorResponse($RequestParams['COMMAND'], '9000',
            '1. Order download service authentication failure - Login/Password supplied did not match['.$q.']', STORE_NAME, ''));
        flush;exit;
	}
	
	 $perms=strtoupper(trim($row->usertype));
//	if(($perms!="SUPER ADMINISTRATOR" && $perms!="DEPRECATED" )) {
//    	if(($perms!="ADMINISTRATOR" && $perms!="DEPRECATED")) {
//            print(xmlErrorResponse($RequestParams['COMMAND'], '9000',
//                'You have a no rights. Access level.', STORE_NAME, ''));
//            flush;exit;
//	}}
//
	list($hash, $salt) = explode(':', $row->password);
	$cryptpass = md5($Password.$salt);
	$res = $hash == $cryptpass;
	$ps_user_id=$row->id;

	if (!$res) {
        print(xmlErrorResponse($RequestParams['COMMAND'], '9000',
            '2. Order download service authentication failure - Login/Password supplied did not match', STORE_NAME, ''));
        flush;exit;
	}

	if ($row->block){
        print(xmlErrorResponse($RequestParams['COMMAND'], '9000',
            'User block. Remove blocking', STORE_NAME, ''));
        flush;exit;

	}
	//Load variable vendor_currency and shopper_group_id

    $q=  "SELECT v.vendor_currency "
        ." FROM #__virtuemart_vendors v "
        ." WHERE v.virtuemart_vendor_id='".$ps_vendor_id."'" ;
  
    $db->SetQuery($q);
	//echo $db->getErrorMsg();
    $row = NULL;
	$row =$db->loadObject();

//	$row=$rows[0];
    $currency ='';

    if($row->vendor_currency) {
        $currency = $row->vendor_currency;

       }



// End load variable
	if (isset($RequestParams['STATUS']))
		define(QB_STATUS, $RequestParams['STATUS']);
	else
    	define(QB_STATUS, "ALL");

	define(QB_PROVIDER, $RequestParams['PROVIDER']);


		$filter_provider=" and o.virtuemart_vendor_id=v.virtuemart_vendor_id ";
		$sql_from_provider=" ,#__virtuemart_vendors v ";

	if (isset($RequestParams['LIMITORDERCOUNT'])&&(int)$RequestParams['LIMITORDERCOUNT']!=0){
		define(QB_ORDERS_PER_RESPONSE, $RequestParams['LIMITORDERCOUNT']);
		$sql_limit_order_count=" LIMIT 0,".(string)(int)QB_ORDERS_PER_RESPONSE;
    }
	else{
    	define(QB_ORDERS_PER_RESPONSE, 25);
		$sql_limit_order_count=" LIMIT 0,25";
    }
    $filter_order_start_number="";
	if (isset($RequestParams['ORDERSTARTNUMBER'])){
  	    define(QB_ORDER_START_NUMBER, $RequestParams['ORDERSTARTNUMBER']);
	    if(QB_ORDER_START_NUMBER>0){
	    	$filter_order_start_number=" AND o.virtuemart_order_id>=".QB_ORDER_START_NUMBER;
		}
    	else{
            define(QB_ORDER_START_NUMBER, 0);
	    }
    }
	else{
        define(QB_ORDER_START_NUMBER, 0);
	}
	if(QB_ORDER_START_NUMBER==0){
    	if (isset($RequestParams['NUMBEROFDAYS'])){
	        define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
    		$date= mktime(0,0,0,date("m"),date("d")-QB_NUMBER_OF_DAYS+1,date("Y"));
	    	$filter_order_start_number=" AND o.cdate>'".(string)$date."'";
        }
	    else{
	        define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
	    	$filter_order_start_number=" AND o.virtuemart_order_id>".QB_ORDER_START_NUMBER;

	    }
    }


	 $xmlResponse = new xml_doc();
	$xmlResponse->version='1.0';
	$xmlResponse->encoding='ISO-8859-1';
	//$xmlResponse->encoding='UTF-8';

	$root = $xmlResponse->createTag("RESPONSE", array('Version'=>'4.1'));
	$envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
	$xmlResponse->createTag("Command", array(), $RequestParams['COMMAND'], $envelope);

     switch ($RequestParams['COMMAND']){

    //***************************************************
    //
    //      get  Orders Service
    //
    //***************************************************

        case 'GETORDERS' : {

				// P Pending 1 1
				// C Confirmed 2 1
				// X Cancelled 3 1
				// R Refunded 4 1
				// S Shipped 5 1

// ïðîâåðêà åñòü ëè çàïèñè â order ñ  èñïîëüçîâàíèåì ôèëüòðà
          $q=  "SELECT COUNT(*) AS Cnt"
                ." FROM #__virtuemart_orders o"
                .$sql_from_provider
                ." WHERE o.order_status NOT IN ('X','R') "
                .$filter_order_start_number
                .$filter_provider
                .$sql_limit_order_count ;



            $db->SetQuery($q);
			
       		$row=null;
	        $row=$db->loadObject();
			;
       	    if(!$row) {
                print(xmlErrorResponse($RequestParams['COMMAND'], '9999-10',
                    "SQL query - ERROR", STORE_NAME, ''));
                flush;exit;
            }
            if (!$row->Cnt){ //íåò çàïèñåé
                print(xmlErrorResponse($RequestParams['COMMAND'], '1000',
                    'No Orders returned', STORE_NAME, ''));
                flush;exit;
            }

        	$xmlResponse->createTag("StatusCode", array(), "0", $envelope);
        	$xmlResponse->createTag("StatusMessage", array(), "All OK", $envelope);
        	$xmlResponse->createTag("Provider", array(), QB_PROVIDER, $envelope);

//,DECODE(pm.order_payment_number,'".ENCODE_KEY."') as payment_number
         

// Start: Ganesh - 29Oct2010
           $q=  "SELECT o.*,ui.*,"
            	." o.cdate odate, op.order_payment_name, op.order_payment_code , op.order_payment_number ,op.order_payment_log ,op.order_payment_trans_id ,op.order_payment_expire,"
                ." v.vendor_id,v.vendor_store_name,ui.zip, pm.payment_method_name, pm.is_creditcard "
                ." FROM #__virtuemart_orders o"
                ." LEFT JOIN #__virtuemart_order_user_info ui ON o.user_id=ui.user_id AND ui.address_type='BT'"
                ."AND o.user_id = ui.user_id AND o.order_id = ui.order_id"
				." LEFT JOIN #__virtuemart_vendor v ON 1 ".$filter_provider
                ." LEFT JOIN #__virtuemart_order_payment op ON o.order_id=op.order_id"
                ." LEFT JOIN #__virtuemart_payment_method pm ON op.payment_method_id=pm.payment_method_id"
                ." WHERE o.order_status NOT IN ('X','R') "
                .$filter_order_start_number
                .$sql_limit_order_count ;
// End: Ganesh - 29Oct2010
 $q=  "SELECT  ui.* , #__virtuemart_countries.country_name , #__virtuemart_states.* , o .*  FROM #__virtuemart_orders o, #__virtuemart_order_userinfos ui " 
 				  ." LEFT JOIN #__virtuemart_countries ON ui.virtuemart_country_id = #__virtuemart_countries.virtuemart_country_id"
				  ." LEFT JOIN #__virtuemart_states ON ui.virtuemart_state_id = #__virtuemart_states.virtuemart_state_id" ;
	       
$q .= " WHERE o.order_status NOT IN ('X','R') AND o.virtuemart_user_id = ui.virtuemart_user_id AND o.virtuemart_order_id = ui.virtuemart_order_id AND ui.address_type ='BT' ". $filter_order_start_number
                .$sql_limit_order_count ;


		 // echo $q ;
            $db->SetQuery($q);
 
$result = $db->loadObjectList();

            $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
         foreach($result as $val){
			 
			 
			 //   echo $val->order_number ; exit ;
			
                $orderNode = $xmlResponse->createTag("Order", array(), '', $ordersNode );
				
								$orderId = $val->virtuemart_order_id;
								$orderNumber = $val->order_number;
				
                $xmlResponse->createTag("OrderID",          array(), $orderId, $orderNode );
                $xmlResponse->createTag("ProviderOrderRef", array(), $orderId, $orderNode );
              //  $xmlResponse->createTag("Date",             array(), $val->created_on.date("Y-m-d",strtotime($val->created_on)),$orderNode );
                $xmlResponse->createTag("Date",             array(), date("Y-m-d",strtotime($val->created_on)),$orderNode );
                $xmlResponse->createTag("Time",             array(), date("H:i:s",strtotime($val->created_on)),$orderNode );
                $xmlResponse->createTag("TimeZone",         array(), 'PST',                        $orderNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("StoreId",          array(), $val->vendor_id,          $orderNode);
                $xmlResponse->createTag("StoreName",        array(), $val->vendor_store_name,  $orderNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("CustomerID",       array(), $val->user_id,            $orderNode);
                $xmlResponse->createTag("SalesRep",         array(), "",                           $orderNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Comment",          array(), $val->customer_note,    $orderNode, __ENCODE_RESPONSE);
           //     $xmlResponse->createTag("Currency",         array(), $val->order_currency,    $orderNode, __ENCODE_RESPONSE);

                $xmlResponse->createTag("CustomField1",array(),$orderNumber , $orderNode );
                $xmlResponse->createTag("CustomField2",array(),"" , $orderNode , __ENCODE_RESPONSE);
                $xmlResponse->createTag("CustomField3",array(),"" , $orderNode , __ENCODE_RESPONSE);
                $xmlResponse->createTag("CustomField4",array(),"" , $orderNode , __ENCODE_RESPONSE);
                $xmlResponse->createTag("CustomField5",array(),"" , $orderNode , __ENCODE_RESPONSE);


                $BillNode = $xmlResponse->createTag("Bill", array(), "", $orderNode);
                $ShipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode);


                if ( $val->order_status == "P"){
                	$xmlResponse->createTag("PayStatus",array(), "Pending",   $BillNode);
                } else {
                	$xmlResponse->createTag("PayStatus",array(), "Cleared",   $BillNode);
                }
				
				$fPaymentQr = "SELECT vo.virtuemart_paymentmethod_id,sm.payment_name, sm.slug from #__virtuemart_orders vo LEFT JOIN #__virtuemart_paymentmethods_en_gb sm ON sm.virtuemart_paymentmethod_id=vo.virtuemart_paymentmethod_id WHERE vo.virtuemart_order_id='".$orderId."'";
				$dbPayment->SetQuery($fPaymentQr);
				$payRes = $dbPayment->loadObjectList();
				
				$xmlResponse->createTag("PayMethod",        array(), $payRes[0]->payment_name,$BillNode);
                //$xmlResponse->createTag("PayMethod",        array(), $db->f("payment_method_name"),$BillNode);

             //   $xmlResponse->createTag("PayStatus", array(), "", $BillNode);
                $xmlResponse->createTag("FirstName", array(), _maxlen($val->first_name,45), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("LastName", array(), _maxlen($val->last_name,45), $BillNode, __ENCODE_RESPONSE);
//                if ($db->f("middle_name")=="")
                    $xmlResponse->createTag("MiddleName", array(), _maxlen($val->middle_name,25), $BillNode);

//                if ($db->f("company")=="")
                    $xmlResponse->createTag("CompanyName", array(), _maxlen($val->company,75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Address1", array(), $val->address_1, $BillNode, __ENCODE_RESPONSE);
//                if ($db->f("address_2")=="")
                    $xmlResponse->createTag("Address2", array(), _maxlen($val->address_2,75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("City", array(), _maxlen($val->city,75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("State", array(), _maxlen($val->state_name,75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Zip", array(), _maxlen($val->zip,75), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Country", array(), _maxlen($val->country_name,75), $BillNode);
                $xmlResponse->createTag("Email", array(), _maxlen($val->email,150), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("Phone", array(), _maxlen($val->phone_1,15), $BillNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("PONumber", array(), _maxlen($orderNumber,25), $BillNode);

        /*???*/if($db->f("is_creditcard")==1){  //this payment work with credit cards?
            // DECODE Account Number
            //echo ("test");


                if( @VM_ENCRYPT_FUNCTION == 'AES_ENCRYPT') {
					define('VM_DECRYPT_FUNCTION', 'AES_DECRYPT');
				} else {
					define('VM_DECRYPT_FUNCTION', 'DECODE');
				}
    	        $dbaccount = new ps_DB;
        	    $q = "SELECT ".VM_DECRYPT_FUNCTION."(order_payment_number,\"".ENCODE_KEY."\") as account_number FROM #__virtuemart_order_payment WHERE order_id='". $orderId."'";
            	$dbaccount->query($q);
	            $dbaccount->next_record();
                $account_number= $dbaccount->f("account_number");
                $AuthDetails= "TransId=".$db->f("order_payment_trans_id").";";
//                $account_number = VM_ENCRYPT_FUNCTION."( '$db->f("order_payment_number")','" . ENCODE_KEY . "')";
								$ReconciliationData = $db->f("order_payment_log");
								$CreditCardTxnResultInfo = array();
								$flRezult = preg_match('|<CustomerCreditCardChargeRs(.*)>(.*)</CustomerCreditCardChargeRs>|Uis', $ReconciliationData, $CreditCardTxnResultInfo);


                $CreditCartNode=$xmlResponse->createTag("CreditCard", array(), $db->f(""), $BillNode);
//                $xmlResponse->createTag("QQQ", array(),$q, $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("CreditCardType", array(), _maxlen($db->f(""),15), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("CreditCardCharge", array(), _maxlen($db->f(""),15), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("ExpirationDate", array(), _maxlen(date("m/Y",$db->f('order_payment_expire')),15), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("CreditCardName", array(), _maxlen($db->f("order_payment_name"),45), $CreditCartNode, __ENCODE_RESPONSE);
//         send only last few digits if security is a concern                                 ***
                $xmlResponse->createTag("CreditCardNumber", array(), _maxlen( $account_number,21), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("CVV2", array(), _maxlen($db->f("order_payment_code"),4), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("AuthDetails", array(), _maxlen($AuthDetails,150), $CreditCartNode, __ENCODE_RESPONSE);
                $xmlResponse->createTag("ReconciliationData", array(), $ReconciliationData, $CreditCartNode, true);//__ENCODE_RESPONSE);
               }


				
				 	
				$fShipQry = "SELECT vo.virtuemart_shipmentmethod_id,sm.shipment_name, sm.slug from #__virtuemart_orders vo LEFT JOIN #__virtuemart_shipmentmethods_en_gb sm ON sm.virtuemart_shipmentmethod_id=vo.virtuemart_shipmentmethod_id WHERE vo.virtuemart_order_id='".$orderId."'";
				$dbShip->SetQuery($fShipQry);
				$shipRes = $dbShip->loadObjectList();
				
				
				$xmlResponse->createTag("ship_method_id", array(), $shipRes[0]->virtuemart_shipmentmethod_id, $ShipNode);
				
				$xmlResponse->createTag("ShipCarrierName", array(), $shipRes[0]->slug, $ShipNode, __ENCODE_RESPONSE);
				
				

				
				$xmlResponse->createTag("ShipMethod", array(), $shipRes[0]->shipment_name, $ShipNode, __ENCODE_RESPONSE);
        if ( $val->order_status == "S"){
        	$xmlResponse->createTag("ShipStatus",array(), "Shipped",   $ShipNode);
        } else {
        	$xmlResponse->createTag("ShipStatus",array(), "New",   $ShipNode);
        }

               
//             Block containing Shipping Address
        // Start: Ganesh - 29Oct2010

			    $q =  "SELECT ui.*  , #__virtuemart_countries.country_name , #__virtuemart_states.* "
	               ." FROM #__virtuemart_orders o"
	               ." ,#__virtuemart_order_userinfos ui"
				  ." LEFT JOIN #__virtuemart_countries ON ui.virtuemart_country_id = #__virtuemart_countries.virtuemart_country_id"
				  ." LEFT JOIN #__virtuemart_states ON ui.virtuemart_state_id = #__virtuemart_states.virtuemart_state_id"
	       
	               ." WHERE 1"
	               ." AND o.virtuemart_user_id=ui.virtuemart_user_id"
	               ." AND o.virtuemart_order_id = ui.virtuemart_order_id"
				   ." AND ui.address_type = 'ST'"
	               ." AND o.virtuemart_order_id=".$val->virtuemart_order_id
	               ;
				  
			    $db->setQuery($q);
				$rec_ext = $db->loadObject();
				
				
				
                if(!$rec_ext->address_type == 'ST' or $rec_ext->address_type == '' or $rec_ext->address_type == 'null')
				{
				 $q =  "SELECT ui.*  , #__virtuemart_countries.country_name , #__virtuemart_states.* "
	               ." FROM #__virtuemart_orders o"
	               ." ,#__virtuemart_order_userinfos ui"
				  ." LEFT JOIN #__virtuemart_countries ON ui.virtuemart_country_id = #__virtuemart_countries.virtuemart_country_id"
				  ." LEFT JOIN #__virtuemart_states ON ui.virtuemart_state_id = #__virtuemart_states.virtuemart_state_id"
	               ." WHERE 1"
	                 ." AND o.virtuemart_user_id=ui.virtuemart_user_id"
	                 ." AND o.virtuemart_order_id = ui.virtuemart_order_id"
				     ." AND ui.address_type ='BT'"
	                 ." AND o.virtuemart_order_id=".$val->virtuemart_order_id
	                 ;
		    	    $db->setQuery($q);
					$rec_ext = $db->loadObject();
		 		}

				
	
				    $xmlResponse->createTag("FirstName", array(), _maxlen($rec_ext->first_name,45), $ShipNode, __ENCODE_RESPONSE);
	                $xmlResponse->createTag("LastName", array(), _maxlen($rec_ext->last_name,45), $ShipNode,  __ENCODE_RESPONSE);
	                $xmlResponse->createTag("MiddleName", array(), _maxlen($rec_ext->middle_name,25), $ShipNode, '');
	                $xmlResponse->createTag("CompanyName", array(), _maxlen($rec_ext->company,75), $ShipNode,  __ENCODE_RESPONSE);
	                $xmlResponse->createTag("Address1", array(), _maxlen($rec_ext->address_1,75), $ShipNode,  __ENCODE_RESPONSE);
	                $xmlResponse->createTag("Address2", array(), _maxlen($rec_ext->address_2,75), $ShipNode, __ENCODE_RESPONSE);
	                $xmlResponse->createTag("City", array(), _maxlen($rec_ext->city,75), $ShipNode,  __ENCODE_RESPONSE);
	                $xmlResponse->createTag("State", array(), _maxlen($rec_ext->state_name,75), $ShipNode,  __ENCODE_RESPONSE);
	                $xmlResponse->createTag("Zip", array(), _maxlen($rec_ext->zip,75), $ShipNode, '');
	                $xmlResponse->createTag("Country", array(), _maxlen($rec_ext->country_name,75), $ShipNode,'');
	                $xmlResponse->createTag("Email", array(), _maxlen($rec_ext->email,150), $ShipNode, '');
	                $xmlResponse->createTag("Phone", array(), _maxlen($rec_ext->phone_1,15), $ShipNode, '');
            
			/* } */
			
              // END: Ganesh - 29Oct2010	    
			   
//             Block containing Items in Orders
               $ItemsNode=$xmlResponse->createTag("Items",array(),"" , $orderNode );
//             Block containing Item in Items

	           $q=  "SELECT oi.*,p.product_weight "
	               ." FROM #__virtuemart_order_items oi "
	               ." LEFT JOIN #__virtuemart_products p ON oi.virtuemart_product_id=p.virtuemart_product_id "
	               ." WHERE 1 "
	               ." AND oi.virtuemart_order_id=".$val->virtuemart_order_id
	               ;
				 
                $db2->setQuery($q);
				
				
				$result3 = $db3->loadObjectList();

         if(is_array($result3))
         foreach($result3 as $val2){
               // while($db2->next_record()){

                    $ItemNode=$xmlResponse->createTag("Item",array(),"" , $ItemsNode );
                    $xmlResponse->createTag("ItemCode",array(),$val2->order_item_sku , $ItemNode, __ENCODE_RESPONSE );
                    $xmlResponse->createTag("ItemDescription",array(),_maxlen($val2->order_item_name,75 ) , $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("Quantity",array(),$val2->product_quantity , $ItemNode );
                    $xmlResponse->createTag("UnitPrice",array(),(float) round($val2->product_item_price,2) , $ItemNode );
                    $item = (float)($result2->product_quantity*$val2->product_item_price);
                    $xmlResponse->createTag("ItemTotal",array(),$item, $ItemNode );
                        
               			if($val2->product_weight!=(float)0) 
               				$xmlResponse->createTag("ItemUnitWeight",array(),($val2->product_weight) , $ItemNode );
                        
                        
                    $xmlResponse->createTag("CustomField1",array(),"" , $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("CustomField2",array(),"" , $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("CustomField3",array(),"" , $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("CustomField4",array(),"" , $ItemNode , __ENCODE_RESPONSE);
                    $xmlResponse->createTag("CustomField5",array(),"" , $ItemNode , __ENCODE_RESPONSE);
//gtht

                    if (!isset($itemOptionsNode)) $itemOptionsNode  = $xmlResponse->createTag("ItemOptions",    array(), '',     $ItemNode, __ENCODE_RESPONSE);
										//
										// Data is stored in DB as 
										// Color: Black<br/> Size: 1 (XS/S)
										//
                    $xmlResponse->createTag("ItemOption", array('Name'=> "Options",'Value'=>$result2->product_attribute),'',$itemOptionsNode, __ENCODE_RESPONSE);
                    //$xmlResponse->createTag("ItemOption", array('Name'=> "Options",'Value'=>$db2->product_attribute")),'',$itemOptionsNode);
                    unset($itemOptionsNode);

                 }   
//             Block containing Order charges
                $is_tax = false;
                $is_shipping = false;
                $is_total = false;
                $is_discount = false;

                $ChargesNode=$xmlResponse->createTag("Charges",array(),"" , $orderNode );
                $xmlResponse->createTag("Shipping",array(),$val->order_shipment , $ChargesNode);
                $xmlResponse->createTag("Handling",array(),"0", $ChargesNode);
               // $xmlResponse->createTag("Tax",array("Name"=>""),round($val->order_shipment_tax  +  $val->order_tax + $val->order_billTaxAmount + $val->order_payment_tax   ,2), $ChargesNode);
                $xmlResponse->createTag("Tax",array("Name"=>""),round($val->order_shipment_tax  +  $val->order_tax  ,2), $ChargesNode);
                $xmlResponse->createTag("TaxOther",array(),"", $ChargesNode);
                $xmlResponse->createTag("Fee",array(),"0", $ChargesNode);
                if ($val->order_discount>0)
                    $xmlResponse->createTag("Discount",array(),$val->order_discountAmount+$val->coupon_discount, $ChargesNode);
                else{
                    $orderChange=-1*$val->order_discount;
                    $xmlResponse->createTag("Discount",array(),$val->coupon_discount+$orderChange, $ChargesNode);
                	$xmlResponse->createTag("OtherCharge",array("Name"=>""),$orderChange, $ChargesNode);
                    }
                if ($db->f("coupon_discount")){
                    $xmlResponse->createTag("GiffCertificate",array(),$val->coupon_discount, $ChargesNode);
                    $flCoupon_discount=true;
                }
                else{
                    $xmlResponse->createTag("GiffCertificate",array(),"", $ChargesNode);
                    $flCoupon_discount=false;
                }
                $xmlResponse->createTag("Total",array(),round($val->order_total,2), $ChargesNode);
                if ($val->coupon_code){
                     $q=  "SELECT c.*"
	                   ." FROM #__virtuemart_coupons  c "
	                   ." WHERE 1"
	                   ." AND c.coupon_code='".$val->coupon_code."'"
	                   ;
                    $db3->setQuery($q);
					$result3 = $db3->loadObjectList();
                    foreach($result3 as $val3){
                        if(!$db3->f("coupon_type")){
                        	$CouponDescription="Coupon type:gift(".$db3->f("percent_or_total").")";
                        }else{
                        	$CouponDescription="Coupon type:".$val3->coupon_type."(".$val3->percent_or_total.")";
                        }
                        $CouponsNode=$xmlResponse->createTag("Coupons",array(),"" , $orderNode );
                        $CouponNode=$xmlResponse->createTag("Coupon",array(),"" , $CouponsNode);
                        $xmlResponse->createTag("CouponCode",array(),$val3->coupon_code, $CouponNode);
                        $xmlResponse->createTag("CouponID",array(),$val3->coupon_id, $CouponNode);
                        $xmlResponse->createTag("CouponDescription",array(),$CouponDescription, $CouponNode);
                        $xmlResponse->createTag("CouponValue",array(),$val3->coupon_value, $CouponNode);
                    }
                }
            }
        }  break;
        //case 'GETORDERS'
    //***************************************************
    //
    //      update Orders Service
    //
    //***************************************************

        case 'UPDATEORDERSSHIPPINGSTATUS' : {
			
			$ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
			$xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
			
			if (count($_tagTags) == 0)  $no_orders = true; else $no_orders = false;
			$xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
			$xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
			if ($no_orders){
    		    print($xmlResponse->generate()); exit;
			}
			
			
			$UpdateTrackingQuery = "";
			$UpdateTrackingHistoryQuery="";
			
			$ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
			foreach($_tagTags as $k=>$v){
			    $order = Array();
				$xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
                $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
                foreach($_orderTags as $k1=>$v1){
                    $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
                    $order[strtoupper($_tagName)] = $_tagContents;
                    if (strtoupper($_tagName)=='HOSTORDERID')
                        $xmlResponse->createTag('HostOrderID',  array(), $_tagContents,     $orderNode);
                    if (strtoupper($_tagName)=='LOCALORDERID')
                        $xmlResponse->createTag('LocalOrderID',  array(), $_tagContents,     $orderNode);
			    }
    		    $result = 'Failed';

                   $q=  "SELECT o.virtuemart_order_id, ui.first_name, ui.last_name, o.order_status, o.modified_on "
						."FROM #__virtuemart_orders o "
						." LEFT JOIN #__virtuemart_userinfos ui ON ui.virtuemart_user_id = o.virtuemart_user_id "
						." WHERE o.virtuemart_order_id = '" . $order['HOSTORDERID'] . "'";
						
                $db->SetQuery($q);
				$r = $db->loadObjectList();

     
                $arrdate=explode("/", $order['SHIPPEDON']);
               if (($r[0]->order_status != __DELIVERED_STATUS_ID)) {
				
				
												//$UpdateTrackingQuery= "update #__virtuemart_orders set "
                        //       ." order_status = '". __DELIVERED_STATUS_ID. "'"
                        //       .", tracking_number = '".$order['TRACKINGNUMBER']. "'"
                        //        ." where virtuemart_order_id = " . $order['HOSTORDERID'];
												$UpdateTrackingQuery= "update #__virtuemart_orders set "
                               ." order_status = '". __DELIVERED_STATUS_ID. "'"
                                ." where virtuemart_order_id = " . $order['HOSTORDERID'];

												
                        $db->SetQuery($UpdateTrackingQuery);
    				   					$db->query();
					   
					    						$comments = "\nOrder shipped on [with t-hub2] ".$order['SHIPPEDON'].
    					            " via ".$order['SHIPPEDVIA']." using ".$order['SERVICEUSED'].
    					            " service\n Tracking Number:".$order['TRACKINGNUMBER'];
    					            
    					            
    					            $UpdateTrackingHistoryQuery= "insert into #__virtuemart_order_histories ( "
                                ." virtuemart_order_history_id, virtuemart_order_id, order_status_code, created_on, customer_notified, comments ) values"
                                ."( '','".$order['HOSTORDERID']."','".__DELIVERED_STATUS_ID . "', now(),'1','". $comments  . "')";
                                 $db->SetQuery($UpdateTrackingHistoryQuery);
								 $db->query();
	                    $result = 'Success';
						
					    		if ((strtoupper($order['NOTIFYCUSTOMER']) == 'YES') || ($order['NOTIFYCUSTOMER'] == '1')){
                       //    _mail($order['HOSTORDERID'],$comments);
    			        }


    			   }  //end of  if (($db->f('order_status') != __DELIVERED_STATUS_ID))
    			   
			   // }
			   
			    $chkFailQr = "SELECT * FROM #__virtuemart_orders WHERE virtuemart_order_id='".$order['HOSTORDERID']."'";
				$db->SetQuery($chkFailQr);
				$chkFailRes = $db->loadObjectList();
				
				
				if($r[0]->order_status=='S')
				$result = 'Success';
				
				if(!count($chkFailRes))
				{
					$result = 'Failed';
					
				}
			    $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
			    $xmlResponse->createTag('HostOrderStatus',  array(), $val2->order_status, $orderNode);
			  //  $xmlResponse->createTag('UpdateTrackingQuery',  array(), $UpdateTrackingQuery, $orderNode);
			  //  $xmlResponse->createTag('UpdateTrackingHistoryQuery',  array(), $UpdateTrackingHistoryQuery, $orderNode);
			    
			}
		} break;  // end of update Orders Shipping Status Service
//      case 'UPDATEORDERSSHIPPINGSTATUS'

    //***************************************************
    //
    //      update  Orders Payment Status Service
    //
    //***************************************************

        case 'UPDATEORDERSPAYMENTSTATUS' : {
			$ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
			$xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
			if (count($_tagTags) == 0)  $no_orders = true; else $no_orders = false;
			$xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
			$xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
			if ($no_orders){
    		    print($xmlResponse->generate()); exit;
			}

			$ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
			foreach($_tagTags as $k=>$v){
			    $order = Array();
				$xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
                $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
                foreach($_orderTags as $k1=>$v1){
                    $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
                    $order[strtoupper($_tagName)] = $_tagContents;
                    if (strtoupper($_tagName)=='HOSTORDERID')
                        $xmlResponse->createTag('HostOrderID',  array(), $_tagContents,     $orderNode, __ENCODE_RESPONSE);
                    if (strtoupper($_tagName)=='LOCALORDERID')
                        $xmlResponse->createTag('LocalOrderID',  array(), $_tagContents,     $orderNode, __ENCODE_RESPONSE);
			    }
    		    $result = 'Failed';

			    $q="SELECT  o.virtuemart_order_id, ui.email,ui.last_name, o.order_status, o.modified_on "
			               ." FROM #__virtuemart_orders o"
			               ." LEFT JOIN #__virtuemart_order_userinfos ui ON (ui.virtuemart_order_userinfo_id =o.virtuemart_user_id)"
			               ." WHERE o.virtuemart_order_id = '" . $order['HOSTORDERID'] . "'";
               // $db->SetQuery($q);
				
				    $db3->setQuery($q);
					$result3 = $db3->loadObjectList();
                    foreach($result3 as $val3){
//                print(xmlErrorResponse($RequestParams['COMMAND'], '9999',$q, STORE_NAME, ''));flush;exit;
              //  if ($db->next_record()) {
				  
                    switch (strtoupper($order['PAYMENTSTATUS'])){
                        case __CLEARED_STATUS_NAME:{
                            $comments = "\nPayment cleared on ".$order['CLEAREDON'];
                            $newstatus=__CLEARED_STATUS_ID;
                            }break;
                        case __PENDING_STATUS_NAME:{
                            $comments = "\nPayment processed offline on ".date("m/d/Y");
                            $newstatus=__PENDING_STATUS_ID;
                        }break;
                        case __DECLINED_STATUS_NAME:{
                            $comments = "\nPayment declined offline on ".date("m/d/Y");
                            $newstatus=__DECLINED_STATUS_ID;
                        }break;
                        case __FRAUD_STATUS_NAME:{
                            $comments = "\nFraud with payment offline on ".date("m/d/Y");
                            $newstatus=__FRAUD_STATUS_ID;
                        }break;
                    }
                    $db2->setQuery("update #__virtuemart_orders set "
                            ." order_status = '".$newstatus."'"
                            .", modified_on =now()"
                            ." where virtuemart_order_id = '" . $order['HOSTORDERID'] . "'");
                   // if (!$db2->next_record()) continue;
					 $db2->query();
					        
                                 $db->SetQuery("insert into #__virtuemart_order_histories ( "
                                ." virtuemart_order_history_id, virtuemart_order_id, order_status_code, created_on, customer_notified, comments ) values"
                                ."( '','".$order['HOSTORDERID']."','".$newstatus . "', now(),'1','". $comments  . "')");
								 $db->query();
                
                    $result = 'Success';

			    }
			    $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
			}

        } break;  // end of update Orders Payment Status Service
//      case 'UPDATEORDERSPAYMENTSTATUS'
	    case 'UPDATEINVENTORY' : {

	        $addProdTag = $xmlRequest->getChildByName(0, "ADDPRODUCTS");
	        $xmlRequest->getTag($addProdTag, $_tagName, $_tagAttributes, $addProd, $_orderTags);

	        $addCategiryTag  = $xmlRequest->getChildByName(0, "ADDCATEGORY");
	        $xmlRequest->getTag($addCategiryTag, $_tagName, $_tagAttributes, $addCategory, $_orderTags);

	        $addManufactTag  = $xmlRequest->getChildByName(0, "ADDMANUFACTURER");
	        $xmlRequest->getTag($addManufactTag, $_tagName, $_tagAttributes, $addManufacturer, $_orderTags);

	        $updDescrTag = $xmlRequest->getChildByName(0, "UPDATEDESCRIPTION");
	        $xmlRequest->getTag(  $updDescrTag, $_tagName, $_tagAttributes, $updDescritpion, $_orderTags);

	        $updPriceTag  = $xmlRequest->getChildByName(0, "UPDATEPRICE");
	        $xmlRequest->getTag($updPriceTag, $_tagName, $_tagAttributes, $updPrice, $_orderTags);

	        $updInvTag      = $xmlRequest->getChildByName(0, "UPDATEINVENTORY");
	        $xmlRequest->getTag($updInvTag, $_tagName, $_tagAttributes, $updInventory, $_orderTags);

	        $itemsTag = $xmlRequest->getChildByName(0, "ITEMS");
	        $xmlRequest->getTag($itemsTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);


	        if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
//	        $xmlResponse->createTag("StoreID",   array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
//	        $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);

	        $items = $xmlResponse->createTag("Items", array(), '', $root);
          
	        $itemsCount = 0;
	        $itemsProcessed = 0;
            foreach($_tagTags as $k=>$itemTag) {   // look thruoght items
				$itemsCount++;
				$code = 0;

				// get item fields
				// ItemCodeParent
				$itemCodeTag = $xmlRequest->getChildByName($itemTag,        "ITEMCODE");           $xmlRequest->getTag($itemCodeTag,  $_tagName, $_tagAttributes,       $itemCode, $_orderTags);
				$itemCodeTagParent = $xmlRequest->getChildByName($itemTag,  "ITEMCODEPARENT");     $xmlRequest->getTag($itemCodeTagParent,  $_tagName, $_tagAttributes, $itemCodeParent, $_orderTags);
				$itemNameTag = $xmlRequest->getChildByName($itemTag,        "ITEMNAME");           $xmlRequest->getTag($itemNameTag, $_tagName, $_tagAttributes,        $itemName, $_orderTags);
				$itemDescrTag = $xmlRequest->getChildByName($itemTag,       "ITEMDESCRIPTION");    $xmlRequest->getTag($itemDescrTag, $_tagName, $_tagAttributes,       $itemDescr, $_orderTags);
				$itemPriceTag = $xmlRequest->getChildByName($itemTag,       "PRICE");              $xmlRequest->getTag($itemPriceTag, $_tagName, $_tagAttributes,       $itemPrice, $_orderTags); 
				$itemSalePriceTag = $xmlRequest->getChildByName($itemTag,   "SALEPRICE");          $xmlRequest->getTag($itemSalePriceTag, $_tagName, $_tagAttributes,   $itemSalePrice, $_orderTags);
				$itemUnitWeightTag = $xmlRequest->getChildByName($itemTag,  "UNITWEIGHT");         $xmlRequest->getTag($itemUnitWeightTag, $_tagName, $_tagAttributes,  $itemUnitWeight, $_orderTags);
				$itemStockTag = $xmlRequest->getChildByName($itemTag,       "QUANTITYINSTOCK");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes,       $itemStock,        $_orderTags);
				$itemManufTag = $xmlRequest->getChildByName($itemTag,       "MANUFACTURER");       $xmlRequest->getTag($itemManufTag, $_tagName, $_tagAttributes,       $itemManufacturer, $_orderTags);
				$itemCategTag = $xmlRequest->getChildByName($itemTag,       "CATEGORY");           $xmlRequest->getTag($itemCategTag, $_tagName, $_tagAttributes,       $itemCategory,     $_orderTags);
				//	              $itemOptionTag = $xmlRequest->getChildByName($itemTag,      "ITEMOPTION");         $xmlRequest->getTag($itemCategTag, $_tagName, $itemOptionAttr,       $itemOption,     $_orderTags);

				// parse options for certain product.
				$xmlRequest->getTag($itemTag, $_tagName, $_tagAttributes, $_tagContents, $_optionsTags);
				$opt_name_array = array();
				$opt_value_array = array();
				//MJ 09/23/2009
				$debugDump = "";
				$dOptionCount = 0;
				
				foreach($_optionsTags as $i=>$optionTag){
				    $xmlRequest->getTag($optionTag, $_tagName, $_tagAttributes, $_tagContents, $sub_optionsTags);
				    if($_tagName != "ITEMOPTION") continue;
				    $opt_name_array[] = $_tagAttributes['NAME'];
				    $opt_value_array[] = $_tagContents;
				    $dOptionCount = $dOptionCount + 1;
				    
				    //if (__DEBUG==1)  $xmlResponse->createTag ("__DEBUG", array(), 'tag_content:'.$_tagContents.", tag attr:".$_tagAttributes['NAME'], $envelope);
				    //$xmlResponse->createTag ("__DEBUG", array(), 'OptionCount:'.$dOptionCount, $envelope);
        }


        	    if ($addProd) { 
                   if (!_AddCategory()){
                        if (__DEBUG==1)_ErrMessageDebug("_AddCategory",$xmlResponse);
                        $code=1;
                     }
                   	if (!_AddManufacturer()){
                   		if(__DEBUG==1)_ErrMessageDebug("__AddManufacturer",$xmlResponse);
                   		    $code=1;
                  		}


		 	 	$sqlstr = "SELECT virtuemart_product_id,  product_in_stock "
					         ." FROM #__virtuemart_products"
                             ." WHERE product_sku = '".$itemCode."'";
							 
							 exit ;
							
                    $db->SetQuery($sqlstr);
					
		            $row=null;
            		$row=$db->loadObject($row);
                    $QuantityInStockWEB=0;
                    $product_parent_id=0;
                    if($row&&$row->product_id) {    // does itemCode exist?

                        $product_id = $row->product_id;
                        $products_model = $itemCode;
                        $QuantityInStockWEB=$row->product_in_stock;

                    } else {
										$itemCodeParent=trim($itemCodeParent);
                         $db->SetQuery("SELECT p.virtuemart_product_id ,p.product_parent_id ,p.product_in_stock,pcx.category_id "
                                  ." FROM #__virtuemart_products p"
                                  ." LEFT JOIN #__virtuemart_product_category_xref pcx ON (pcx.virtuemart_product_id=p.virtuemart_product_id)"
                                  ." WHERE product_sku = '".$itemCodeParent."'");
        	            $row=null;
                		$row=$db->loadObject($row);

		                if($row) {  // does itemCodeParent exist?
                            if ($row->product_id){
                                $product_id = $row->product_id;
                                $tmp_category_id = $row->category_id;
                                $product_parent_id=$product_id;
                                $products_model = $itemCode;
                                $flAppOptionSKU = false;
																$flAddProductParent =false;
                            }
                        }else{
							
												
														$flAppOptionSKU = true;
														$flAddProductParent =true;
                            $products_model = $itemCode;
                            $product_parent_id=0;
												}
												if ($dOptionCount == 0) {
													$flAddProductParent = false;
												}
												if (!empty($itemCodeParent) && ($itemCodeParent != $itemCode)&& 
															($flAddProductParent)){
                              //ñîçäàåì ïðåäêà
                            $db->SetQuery(" INSERT INTO #__virtuemart_products "
                                    .  " (virtuemart_product_id, vendor_id, product_parent_id, product_sku, product_s_desc,"
                                    .  "    product_desc,  product_publish, "
                                    .  "    product_weight, product_weight_uom,  product_in_stock,"
                                    .  "    product_available_date, cdate, mdate, product_name ,product_length,"
                                    .  "    product_width, product_height,product_url ,product_special, "
                                    .  "    product_discount_id,product_unit, product_packaging ,attribute ) values"
                                    .  " ('','$ps_vendor_id', '$product_parent_id','$itemCodeParent', '$itemDescr', "
                                    .  " '$itemDescr','N','$itemUnitWeight','','$itemStock','".date("U")."','".date("U")."', '".date("U")."','$itemName',0,0,0,'','N',0,'',0,'')");

                	        if ($db->_database->_errorNum){
                                $_err_message_arr[] = "Cannot execute INSERT NEW product. Item Code = $products_model";
                                $_err_message_arr[] = $db->getErrorMsg();
								$code = 1;
                            } else { // insert or assign category to new product
                                $product_parent_id = $db->last_insert_id();
	                            $db->SetQuery(" INSERT INTO  #__virtuemart_product_category_xref  "
	                                    .  " ( virtuemart_product_id, category_id ) Values "
	                                    .  " ('$product_parent_id', '$category_id')");

                	            if ($db->_database->_errorNum){
                				    $_err_message_arr[] = "Cannot execute INSERT to table _product_category_xref.";
	                                $_err_message_arr[] = $db->getErrorMsg();
	                                $code = 1;
                                } // insert or assign manufacturer to new product
	                            $db->SetQuery(" INSERT INTO  #__virtuemart_product_mf_xref  "
	                                    .  " ( virtuemart_product_id,  manufacturer_id) Values "
	                                    .  " ('$product_parent_id', '$manufacturer_id')");

                	            if ($db->_database->_errorNum){
                				    $_err_message_arr[] = "Cannot execute INSERT to table _product_mf_xref.";
	                                $_err_message_arr[] = $db->getErrorMsg();
	                                $code = 1;
                		        }
														 if ($itemPrice){ //
                             				if(!_AddPrice($product_parent_id)){
                                    	$code = 1;
                                    	if(__DEBUG==1) _ErrMessageDebug("_AddPrice", $xmlResponse);
                                    }
            	        	    }
                		        //for function _AddOptionSku
                		        $product_id=$product_parent_id;
                                foreach ($opt_name_array as $i=>$nameOption){
                                    if ($flAppOptionSKU )
                                        if(!_AddOptionSku($nameOption,$cnt++)){
                                    	$code = 1;
                                    	if(__DEBUG==1) _ErrMessageDebug("_AddOptionSku", $xmlResponse);
                                    }
                                }

                            }


                        }



                    	if (!$flAppOptionSKU)$category_id=$tmp_category_id;// add to categoty where itemCodeParent

                            $db->SetQuery(" INSERT INTO #__virtuemart_product "
                                    .  " (product_id, vendor_id, product_parent_id, product_sku, product_s_desc,"
                                    .  "    product_desc,  product_publish, "
                                    .  "    product_weight, product_weight_uom,  product_in_stock,"
                                    .  "    product_available_date, cdate, mdate, product_name ,product_length,"
                                    .  "    product_width, product_height,product_url ,product_special, "
                                    .  "    product_discount_id,product_unit, product_packaging ,attribute ) values "
                                    .  " ('','$ps_vendor_id', '$product_parent_id','$products_model', '$itemDescr', "
                                    .  " '$itemDescr','N','$itemUnitWeight','','$itemStock','".date("U")."','".date("U")."', '".date("U")."','$itemName',0,0,0,'','N',0,'',0,'')");

                	        if ($db->_database->_errorNum){
                                $_err_message_arr[] = "Cannot execute INSERT NEW product. Item Code = $products_model";
                                $_err_message_arr[] = $db->getErrorMsg();
								$code = 1;
                            } else { // insert or assign category to new product
                                $product_id = $db->last_insert_id();

	                            $db->SetQuery(" INSERT INTO  #__virtuemart_product_category_xref  "
	                                    .  " ( product_id, category_id ) Values "
	                                    .  " ('$product_id', '$category_id')");

                	            if ($db->_database->_errorNum){
                				    $_err_message_arr[] = "Cannot execute INSERT to table _product_category_xref.";
	                                $_err_message_arr[] = $db->getErrorMsg();
	                                $code = 1;
                                } // insert or assign manufacturer to new product
	                            $db->SetQuery(" INSERT INTO  #__virtuemart_product_mf_xref  "
	                                    .  " ( product_id,  manufacturer_id) Values "
	                                    .  " ('$product_id', '$manufacturer_id')");

                	            if ($db->_database->_errorNum){
                				    $_err_message_arr[] = "Cannot execute INSERT to table _product_mf_xref.";
	                                $_err_message_arr[] = $db->getErrorMsg();
	                                $code = 1;
                		        }
                                if ($itemPrice){ //
                                    if(!_AddPrice()){
                                    	$code = 1;
                                    	if(__DEBUG==1) _ErrMessageDebug("_AddPrice", $xmlResponse);
                                    }
            	        	    }

                            }
                            // end of else for ItemCodeParent
                    }        // end of else for ItemCode
                    $cnt=0;
   					foreach ($opt_name_array as $i=>$nameOption){
                        if(!_AddOption($nameOption,$opt_value_array[$i])){
                        	$code = 1;
                            if(__DEBUG==1)_ErrMessageDebug("_AddOption", $xmlResponse);
                        }
                    }
                    if ($code!=1) $itemsProcessed++;

              // creat xml output
                    $item = $xmlResponse->createTag("Item", array(), '', $items);
                    $xmlResponse->createTag("ItemCode", array(), $products_model, $item, __ENCODE_RESPONSE);
                    $xmlResponse->createTag("InventoryUpdateStatus", array(), "$code", $item);
                    $xmlResponse->createTag("QuantityInStockWEB", array(), "$QuantityInStockWEB", $item);
                    _ErrMessageDebug();

//          if ($addProd)
                }
                else{  // Not flag AddProduct
				
                    $itemsProcessed++;
                      

                    if ($updPrice){
                    	if ($itemCode){
			        		 $sqlstr = "SELECT virtuemart_product_id,  product_in_stock "
			            		         ." FROM #__virtuemart_products"
                                     ." WHERE product_sku = '".$itemCode."'";
									 
                            $db->SetQuery($sqlstr);
		                    $row=null;
							
                    		$row=$db->loadObjectList();
							
                            if($row&&$row[0]->virtuemart_product_id ) {    // does itemCode exist?
                                $product_id = $row[0]->virtuemart_product_id ;
                                   if(!_UpdPrice($product_id,$itemPrice)){
                                       if(__DEBUG==1)_ErrMessageDebug("_UpdPrice", $xmlResponse);
                                		$code=1;
                                   }
                            }
                        }
                    }//              End section add Manufacturer Navin
                    if ($updInventory){
						
						
	
                    	if ($updInventory==1){
	                        $_err_message_arr = Array();

			        		$sqlstr = "SELECT virtuemart_product_id as product_id,  product_in_stock "
			            		         ." FROM #__virtuemart_products"
                                     ." WHERE product_sku = '".$itemCode."'";
                            $db->SetQuery($sqlstr);
							
		                    $row=null;
                    		$row=$db->loadObjectList();
                            $QuantityInStockWEB=-9999;
                            $products_model=$itemCode;
                            $code=0;
                            if($row&&$row[0]->product_id) {    // does itemCode exist?
                                $product_id = $row[0]->product_id;
                                $products_model = $itemCode;
                                $QuantityInStockWEB=$row->product_in_stock;
           			        	foreach ($opt_name_array as $i=>$nameOption){ 
							
                                    if(!_UpdOption($product_id,$nameOption,$opt_value_array[$i])){
                                        if(__DEBUG==1)_ErrMessageDebug("_UpdOption", $xmlResponse);
                                        $code = 1;
                                    }
                                }


                               			 $set = " product_in_stock ='$itemStock'";
										
										$db->SetQuery(" UPDATE  #__virtuemart_products SET "
                   	                        .  " modified_on = now(),"
                                            .  $set
                                            .  " WHERE virtuemart_product_id='$product_id'");
											
											$result = $db->query();
											
						    					    	    if ($db->_database->_errorNum){
                                           $_err_message_arr[] = "Cannot execute UPDATE to table _product. Row:product_name |product_desc   ";
                                           $_err_message_arr[] = $db->getErrorMsg();
                                           $code = 1;
                                    }

                                if ($itemPrice){ //
                    							if ($updPrice){                               	
                                   if(!_UpdPrice($product_id,$itemPrice)){
                                   	    if(__DEBUG==1)_ErrMessageDebug("_UpdPrice", $xmlResponse);
                                       $code=1;
                                   }
                                  }
                                }
                                
               							foreach ($opt_name_array as $i=>$nameOption){
                                    if(!_UpdOption($product_id,$nameOption,$opt_value_array[$i])){
                                    	if(__DEBUG==1)_ErrMessageDebug("_AddOption", $xmlResponse);
                                    	$code=1;
                                    }
                                }
                            }

                            else{//not ptoduct itemCode
                                $code=1;
                            }
                        //$addInventory=1
                        }//$addInventory
                    }



//*********************  for future use ***************************
//**                                                           //**
//**                    if ($updDescritpion){                  //**
//**                        if (!_UpdDescritpion()){           //**
//**                        	_ErrMessageDebug();            //**
//**                    }   }                                  //**
//*****************************************************************
                    $item = $xmlResponse->createTag("Item", array(), '', $items);
                    $xmlResponse->createTag("ItemCode", array(), $products_model, $item, __ENCODE_RESPONSE);
                    $xmlResponse->createTag("InventoryUpdateStatus", array(), "$code", $item);
                    $xmlResponse->createTag("QuantityInStockWEB", array(), "$QuantityInStockWEB", $item);

                }

            }
//              foreach($_tagTags as $k=>$itemTag)  look thruoght items

        if ( $itemsProcessed == $itemsCount ) {
        	$code = "0";
        	$message = "All Ok";
        } elseif( $itemsProcessed == 0 ){
            $code = "0";
            $message = "Warning: No items processed";
        } else {
        	$code = "0";
        	$message = "Warning: ".$itemsProcessed."/".$itemsCount." items processed";
        }

        $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
        $xmlResponse->createTag("StatusMessage", array(), $message, $envelope);
        $xmlResponse->createTag("Provider", array(), "GENERIC", $envelope);
        }
//      case 'UPDATEINVENTORY' :


    }
     //switch ($RequestParams['COMMAND'])

    header("Content-type: application/xml");
    print($xmlResponse->generate());


function _UpdPrice($product_id,$itemPrice){
//global $db,$_err_message_arr,$itemPrice,$currency,$shopper_group_id;

	$flRezult = true;
	$db = &JFactory::getDBO();
	
	
	
		
	
	    $db->SetQuery(" SELECT *  FROM #__virtuemart_product_prices  "
	            .  " WHERE virtuemart_product_id='$product_id'");
	    $row=null;
		
	    $row=$db->loadObjectList();

	    if($row) {
			
		
	        $db->SetQuery(" UPDATE  #__virtuemart_product_prices SET "
	                .  "  product_price ='$itemPrice',"
	                .  "  modified_on  =Now()"
	                .  " WHERE virtuemart_product_id='$product_id'"
    	           );
			$result = $db->query();
	        if ($db->_database->_errorNum){
	            $_err_message_arr[] = "Cannot execute UPDATE to table _product_price." ;
	            $_err_message_arr[] = $db->getErrorMsg();
	        	$flRezult = false;
	        }
	    }else{
	    	$flRezult=_AddPrice();
	    }
	
	return $flRezult;
}

function _AddPrice($id=''){
    global $db,$_err_message_arr,$product_id,$itemPrice,$currency,$shopper_group_id;
	$flRezult = true;
	if (empty($id)){
		$id=$product_id;
	}
	$db->SetQuery(" INSERT INTO #__virtuemart_product_price "
	        .  " ( 	product_price_id,product_id,product_price,product_currency,"
        	.  "    cdate,	mdate,shopper_group_id) VALUES"
        	.  " ('','".$id."', '$itemPrice', '$currency', "
        	.  " '".date("U")."','".date("U")."','$shopper_group_id')");

	if ($db->_database->_errorNum){
    	$flRezult = true;
    	$_err_message_arr[] = "Cannot execute INSERT NEW _product_price.";
	    $_err_message_arr[] = $db->getErrorMsg();
	}
	return $flRezult;
}

function _UpdOption($product_id,$nameOption='',$valueOption=''){
	
    global $db,$_err_message_arr;
	$db = &JFactory::getDBO();
	$db1 = &JFactory::getDBO();
	$flRezult = true;
	if($product_id!="" && !empty($nameOption)&&!empty($valueOption)) {
		
		
	
			$db->SetQuery("SELECT cm . * , cus . *
			FROM `ho3q7_virtuemart_product_customfields` AS cm, ho3q7_virtuemart_customs AS cus
			WHERE cm.`virtuemart_custom_id` = cus.`virtuemart_custom_id` and virtuemart_product_id=".$product_id." and custom_title='".$nameOption."'");
	    $row=null;
		
	     $row=$db->loadObjectList();       //navin2
     
	    if(count($row[0]) !=0) {
	       
	        $db1->SetQuery(" UPDATE  #__virtuemart_product_customfields SET "
	                .  "   custom_value='".$valueOption."'"
	                .  " WHERE virtuemart_customfield_id=".$row[0]->virtuemart_customfield_id);
				   
				$result = $db1->query();	
				  
	        if (false){
	            $_err_message_arr[] = "Cannot execute UPDATE to table _product_attribute. Option:".$nameOption.",value:".$valueOption;
	            $_err_message_arr[] = $db->getErrorMsg();
	        	$flRezult = false;
	        }
	    }else{
	    	$flRezult=_AddOption($product_id,$nameOption,$valueOption);
	    }
    } else $flRezult = false;
	
	return $flRezult;
}


function _AddOption($product_id,$nameOption='',$valueOption=''){
		$db = &JFactory::getDBO();
    global $db,$_err_message_arr;
	$flRezult = true;
		$db->SetQuery("SELECT cm . * , cus . *
			FROM `ho3q7_virtuemart_product_customfields` AS cm, ho3q7_virtuemart_customs AS cus
			WHERE cm.`virtuemart_custom_id` = cus.`virtuemart_custom_id` and virtuemart_product_id=$product_id and custom_title='".$nameOption."'");
		$result = $db->query();		
    $row=null;
    $row=$db->loadObjectList(); 
    if(!$row) {
        $db->SetQuery(" INSERT INTO #__virtuemart_product_customfields  "
                .  " ( virtuemart_product_id, custom_value, custom_price) Values "
                .  " ('".$product_id."', '".$nameOption."','".$valueOption."')");
        if ($db->_database->_errorNum){
            $_err_message_arr[] = "Cannot execute INSERT to table _product_attribute. Option:".$nameOption.",value:".$valueOption;
            $_err_message_arr[] = $db->getErrorMsg();
        	$flRezult = false;
        }
    }
	return $flRezult;
}
function _AddOptionSku($nameOption,$numlist=0){
    global $db,$_err_message_arr,$product_id;

	$flRezult = true;
	$db->SetQuery(" SELECT *  FROM #__virtuemart_product_attribute_sku  "
	        .  " WHERE product_id='".$product_id."'"
        	.  " AND  attribute_name='".$nameOption."'");
	$row=null;
	$row=$db->loadObject($row);
	if(!$row) {
    	$db->SetQuery(" INSERT INTO  #__virtuemart_product_attribute_sku  "
	            .  " ( product_id, attribute_name, attribute_list) Values "
            	.  " ('".$product_id."', '".$nameOption."','".$numlist."')");
    	if ($db->_database->_errorNum){
        	    $_err_message_arr[] = "Cannot execute INSERT to table _product_attribute_sku.Option:".$nameOption;
            	$_err_message_arr[] = $db->getErrorMsg();
            	$flRezult = false;
	    }
	}
	return 	$flRezult;
}

function _UpdDescritpion(){
    global $itemDescr, $itemCode,$db,$_err_message_arr,$product_id;

	$itemDescr= trim($itemDescr);
	$itemDescr= addslashes(trim($itemDescr));
	$flRezult = true;
	if ($itemDescr) {
		$q=" SELECT product_id "
		           ." FROM #__virtuemart_product"
		           ." WHERE product_sku = '$itemCode'";
		$db->SetQuery($q);
		$row=null;
		$row=$db->loadObject($row);
	    if($row) {  // does Manufacturer exist?
	        if ( $row->product_id){
	        	$product_id=$row->product_id;
	    		$q=" UPDATE #__virtuemart_product SET product_desc='$itemDescr'"
			               ." WHERE product_id = '$product_id'";
				$flRezult = false;
			    $db->SetQuery($q);
	            if ($db->_database->_errorNum){
					$flRezult = false;
				    $_err_message_arr[] = "Cannot execute UPDATE description.";
	                $_err_message_arr[] = $db->getErrorMsg();
		        }
            }
        }
        else {
			$flRezult = false;
		    $_err_message_arr[] = "Cannot find product: $itemCode ";
        }
    }
    return $flRezult;
}

function _AddManufacturer(){
    global $itemManufacturer, $manufacturer_id,$xmlResponse,$db,$_err_message_arr;

	$itemManufacturer = trim($itemManufacturer);
	$itemManufacturer = addslashes(trim($itemManufacturer));
    $flRezult = true;
	if ($itemManufacturer) {
		$q=" SELECT manufacturer_id "
		           ." FROM #__virtuemart_manufacturer"
		           ." WHERE mf_name = '$itemManufacturer'";
		$db->SetQuery($q);
		$row=null;
		$row=$db->loadObject($row);
	    if( $row) {  // does Manufacturer exist?
			if ($row->manufacturer_id){
                $manufacturer_id = $row->manufacturer_id;
            }
        }
        else {
			$q="INSERT INTO #__virtuemart_manufacturer"
			          ." (manufacturer_id,mf_name,mf_email,mf_desc , mf_category_id , mf_url)"
			          ." VALUES ('','$itemManufacturer',NULL,NULL,'1','')";
			$db->SetQuery($q);
            if ($db->_database->_errorNum){
				$flRezult = false;
			    $_err_message_arr[] = "Cannot execute INSERT NEW manufacturer. Manufacturer = $itemManufacturer";
                $_err_message_arr[] = $db->getErrorMsg();
			} else {
			    $manufacturer_id = $db->last_insert_id();
			}
        }
	}
	else {
        $manufacturer_id = 0;
        $flRezult = false;
	    $_err_message_arr[] = "itemManufacturer is EMPTY";
    }
    return $flRezult;
}

function _AddCategory(){
    global $itemCategory, $category_id,$db,$_err_message_arr,$ps_vendor_id;

	$itemCategory = trim($itemCategory);
	$category_id = 0;
	$category_child_id=0;

	$flRezult = true;
	if ($itemCategory) {
	    $categories = explode("/", $itemCategory);
    	$category_ids = Array();
        foreach ($categories as $category){
	        $category = addslashes(trim($category));

	        if ($category) {
	            $sqlstr = "SELECT c.category_id, cx.category_parent_id "
	                     ." FROM #__virtuemart_category c"
                         ." LEFT JOIN #__virtuemart_category_xref cx ON (cx.category_child_id=c.category_id )"
	                     ." WHERE c.category_name = '".$category."'"
	                     ." AND cx.category_parent_id = '".$category_child_id."'";

            	$db->SetQuery($sqlstr);
        		$row=null;
		        $row=$db->loadObject($row);
        	    if($row) {// does Category exist?
	                if ($row->category_id){
	                    $category_id = $row->category_id;
	                    $category_child_id =$category_id ;
                    }
	            }
	            else {
	                $q="INSERT INTO #__virtuemart_category"
	                          . " (category_id, vendor_id,category_name, category_description,category_thumb_image, category_full_image, category_publish,cdate, mdate,category_browsepage,products_per_row, category_flypage, list_order   ) "
	                          . " values ('','$ps_vendor_id','$category','$category', '','','Y','".date("U")."','".date("U")."','".CATEGORY_TEMPLATE."','1','".FLYPAGE."','1')";
                    $db->SetQuery($q);
	                if ($db->_database->_errorNum){
	                	$flRezult = false;
                        $_err_message_arr[] = "Cannot execute INSERT NEW category. Category = $itemCategory";
                        $_err_message_arr[] = $db->getErrorMsg();
       				} else {
                        $category_id = $db->last_insert_id();
		                $db->SetQuery("INSERT INTO #__virtuemart_category_xref "
		                        . " (category_parent_id, category_child_id ) VALUE"
		                        . " ('$category_child_id', '$category_id' )");//0- root category

	                    if ($db->_database->_errorNum){
    	                	$flRezult = false;
               			    $_err_message_arr[] = "Cannot execute INSERT NEW category_xref. Category = $itemCategory";
               			    $_err_message_arr[] = $db->getErrorMsg();
    	                }
		                else $category_child_id = $category_id;
       				}
	            }
		        $category_ids[] = $category_id;
			}
		} // categories loop
	}else{
        $flRezult = false;
        $category_id = 0;
	    $_err_message_arr[] = "itemCategory is EMPTY";
	}
	return $flRezult;
}

function _ErrMessageDebug($section="__DEBUG",$xmlResponse){
    global 	$_err_message_arr, $envelope;
    foreach($_err_message_arr as $k=>$msg) {   // look thruoght items
        $xmlResponse->createTag($section, array(), $msg, $envelope);
    }
    $_err_message_arr=array();
}

function _mail($order_id,$comments){
		global 	$ps_vendor_id,	$VM_LANG, $mosConfig_live_site,$mosConfig_mailer;
//		, $mosConfig_smtpauth, $mosConfig_mailer,$mosConfig_smtpuser, $mosConfig_smtppass, $mosConfig_smtphost;
        $mosConfig_mailer="sendmail";

      $db_mail = &JFactory::getDBO();
        $d=array("order_id"=>$order_id);
		$q = "SELECT vendor_name  FROM #__virtuemart_vendors ";
		 $q .= "WHERE virtuemart_vendor_id=$ps_vendor_id";
	
		$db_mail->setQuery($q);
		
		
		$q = "SELECT first_name, last_name, email, order_status_name ";
        $q .= " FROM #__virtuemart_order_userinfos AS ui, #__virtuemart_orders, #__virtuemart_orderstates";
        $q .= " WHERE #__virtuemart_orders.virtuemart_order_id = '".$d["order_id"]."' ";
        $q .= " AND #__virtuemart_orders.virtuemart_user_id = ui.virtuemart_user_id";
        $q .= " AND #__virtuemart_orders.virtuemart_order_id = ui.virtuemart_order_id";
        $q .= " AND order_status = order_status_code" ;
		
		
		
		
		$db_mail->setQuery($q);
		$result = $db_mail->loadObjectList();
      
		/* MAIL BODY */
		$message = $VM_LANG->_HI. ' ' . $result[0]->first_name .($result[0]->middle_name?' '.$result[0]->middle_name : '' ). ' '  . $result[0]->last_name . ",\n\n";
		$message .= $VM_LANG->_PHPSHOP_ORDER_STATUS_CHANGE_SEND_MSG_1."\n\n";

		if( !empty($d['include_comment']) && !empty($d['order_comment']) ) {
			$message .= $VM_LANG->_PHPSHOP_ORDER_HISTORY_COMMENT_EMAIL.":\n";
			if( get_magic_quotes_gpc() ) {
				$d['order_comment'] = stripslashes( $d['order_comment'] );
			}
			$message .= $d['order_comment'];
			$message .= "\n____________________________________________________________\n\n";
		}

		$message .= $VM_LANG->_PHPSHOP_ORDER_STATUS_CHANGE_SEND_MSG_2.": ";
		$message .= $result[0]->order_status_name;
		$message .= "\n____________________________________________________________\n\n";
		$message .= $comments;
		$message .= "\n\n____________________________________________________________\n";
		$message .= $result[0]->vendor_name . " \n";
		$message .= $mosConfig_live_site."\n";
		$message .= $result[0]->email;

		$message = str_replace( "{order_id}", $d["order_id"], $message );

		$mail_Body = html_entity_decode($message);
		$mail_Subject = str_replace( "{order_id}", $d["order_id"], html_entity_decode($VM_LANG->_PHPSHOP_ORDER_STATUS_CHANGE_SEND_SUBJ));


		//$result = vmMail( $result[0]->email,  $result[0]->vendor_name,$result[0]->email, $mail_Subject, $mail_Body, '' );
        $mailer =& JFactory::getMailer();
		$mailer->addRecipient($result[0]->email);
		$mailer->setSubject($mail_Subject . " ( ".$result[0]->vendor_name.")");
		$mailer->setBody($mail_Body);
  //print(xmlErrorResponse($RequestParams['COMMAND'], '9999-1',$result , STORE_NAME, ''));flush;exit;

       //   $send =& $mailer->Send();


		/* Send the email */
		//modif
		return $send;


}



function xmlErrorResponse($command, $code, $message, $provider, $request_id='') {
  header("Content-type: application/xml");
  $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>');
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.0'));
  //print("i'm here");
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $command, $envelope);
  $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
  $xmlResponse->createTag("StatusMessage", array(), _maxlen($message,__STATUS_MESSAGE_MAX_LENGTH), $envelope);
  //if ($request_id) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
  //$xmlResponse->createTag("Provider", array(), $provider, $envelope);
  return $xmlResponse->generate();
}


    function _maxlen($str,$len){

        if (strlen($str)>$len)
           return substr($str,0,$len);
        else
           return $str;
    }



function objectToArray($d) {
		if (is_object($d)) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars($d);
		}
 
		if (is_array($d)) {
			/*
			* Return array converted to object
			* Using __FUNCTION__ (Magic constant)
			* for recursive call
			*/
			return array_map(__FUNCTION__, $d);
		}
		else {
			// Return array
			return $d;
		}
	}
?>
